> For the complete documentation index, see [llms.txt](https://docs.idew.org/code-chatbot/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.idew.org/code-chatbot/code-mods/placing-js-functions-in-a-separate-file.md).

# Placing JS Functions in your Main JS File

**For your chatbot we recommend that you place the bulk of your Javascript work in a proper Javascript file and keep your Rivescript "objects" very simple.**

## An Example...

Your *Rivescript* file could simply call a Javascript function like below.

{% code title="Rivescript" %}

```javascript
> object getRandomTerm javascript
  return getRandomTerm();
< object

+ random
- Finding a random term... <call>getRandomTerm</call>
```

{% endcode %}

Notice how this will run the `getRandomTerm()` function, like the one below, that can be in your *code.js* file.

{% code title="Javascript" %}

```javascript
function getRandomTerm() {
  var randomIndex = Math.floor(Math.random() * chatbot.db.length);
  currentItem = chatbot.db[randomIndex]
  return currentItem.term;
}
```

{% endcode %}

**The chain of returns:** The Javascript function will *return* the "term" (in this case) to the Rivescript object, which will then return that value to your script file

{% hint style="info" %}
**Placing JavaScript in a proper `.js` file produces the familiar code highlighting that makes your code much easier to write, edit, and debug.**
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.idew.org/code-chatbot/code-mods/placing-js-functions-in-a-separate-file.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
